# -*- coding: utf-8 -*-
from setuphelpers import *
from waptutils import create_recursive_zip
from waptutils import CustomZipFile


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    path_selenium = makepath(basedir, "selenium")
    mkdirs(path_selenium)
    if get_os_name() == "Windows":
        pathwaptpython = makepath(WAPT.wapt_base_dir, "waptpython.exe")
    else:
        pathwaptpython = makepath(WAPT.wapt_base_dir, "waptpython.sh")

    if proxies:
        run('"%s" -m pip install selenium --target="%s" --proxy="%s"' % (pathwaptpython, path_selenium, proxies["http"]))
    else:
        run('"%s" -m pip install selenium --target="%s"' % (pathwaptpython, path_selenium))
    version = glob.glob(makepath(path_selenium, "selenium-*.dist-info"))[0].rsplit("-", 2)[-2].rsplit(".", 1)[0]
    create_recursive_zip(CustomZipFile(r"selenium.zip", "w"), path_selenium)

    dir_list = glob.glob("*%s*/" % pkg_name.split("-", 1)[1])
    for folder in dir_list:
        create_recursive_zip(CustomZipFile(folder.split(os.sep)[0] + ".zip", "w"), folder)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
