# Please check edit_config_raw_file.py


def session_setup():
    user_conf_dir = makepath(application_data, "Greenshot")
    user_conf_path = makepath(user_conf_dir, "Greenshot.ini")
    print(f"Updating: {user_conf_path}")
    if not isdir(user_conf_dir):
        mkdirs(user_conf_dir)
    lang = get_language(full_locale=True, separator="-")  # fr-FR

    # Editting user_conf
    killalltasks(ensure_list(control.impacted_process))
    encoding = detect_file_encoding(user_conf_path)
    new_lines = []
    with open(user_conf_path, "r", encoding=encoding) as f:
        for line in f.readlines():
            if line.startswith("UpdateCheckInterval"):
                line = "UpdateCheckInterval=%s\n" % "0"
            if line.startswith("Language"):
                line = "Language=%s\n" % lang
            if line.startswith("Destinations"):
                line = "Destinations=%s\n" % "Editor"
            if line.startswith("CaptureMousepointer"):
                line = "CaptureMousepointer=%s\n" % "False"
            if line.startswith("OutputFilePath"):
                user_screenshots_dir = makepath(user_home_directory, "Pictures", "Screenshots")
                if isdir(user_screenshots_dir):
                    line = "OutputFilePath=%s\n" % user_screenshots_dir
            new_lines.append(line)
    with open(user_conf_path, "w", encoding=encoding) as f:
        f.writelines(new_lines)

    # Changing setup.py appx_package_name variable
    new_lines = []
    with open("setup.py", "r", encoding="utf8") as f:
        for line in f.readlines():
            if line.startswith("appx_package_name"):
                line = 'appx_package_name = "%s"\n' % appx_package_name
            new_lines.append(line)
    with open("setup.py", "w", encoding="utf8") as f:
        f.writelines(new_lines)


# Tests whitout VM
with open(wapt_get_ini_luti, "r") as f:
    print('echo %s > "%s"' % (f.readline(), vm_inifile))
    for line in f.readlines():
        print('echo %s >> "%s"' % (line, vm_inifile))

    # Applying locale as default
    if default_locale:
        print("Applying: %s as default locale" % default_locale)
        user_argv_conf_content = '{"locale": "%s"}' % default_locale
        user_argv_conf_data = json.loads(user_argv_conf_content)
        if not isdir(user_app_dir):
            mkdirs(user_app_dir)
        if not isfile(user_argv_conf_file):
            print("Creating: %s" % user_argv_conf_file)
            json_write_file(user_argv_conf_file, user_argv_conf_data)
        else:
            with open(user_argv_conf_file, "r+") as opened_file_lines:
                file_changed = False
                locale_found = False
                new_data = []
                for line in opened_file_lines.readlines():
                    if '"crash-reporter-id"' in line:
                        if not "," in line:
                            line = line.replace("\n", ",\n")
                            file_changed = True
                    if '"locale"' in line:
                        locale_found = True
                        if not '"locale": "%s"' % default_locale in line:
                            line = '\t"locale": "%s",\n' % default_locale
                            file_changed = True
                    new_data.append(line)
                if file_changed:
                    print("Updating: %s" % user_argv_conf_file)
                    opened_file_lines.seek(0)  # Return to the top of the file
                    opened_file_lines.truncate(0)  # Erase next content of the file
                    opened_file_lines.writelines(new_data[0:])  # Writing new data to the file
            if not locale_found:
                print("Updating: %s" % user_argv_conf_file)
                with open(user_argv_conf_file, "r+") as opened_file:
                    file_content = opened_file.read()
                    file_content = file_content.replace("}", '\t"locale": "%s",\n}' % default_locale)
                    opened_file.seek(0)  # Return to the top of the file
                    opened_file.truncate(0)  # Erase next content of the file
                    opened_file.write(file_content)
    else:
        print("Resetting default locale")
        with open(user_argv_conf_file, "r") as opened_file:
            file_content = opened_file.read()
            if '"locale"' in file_content:
                print("Updating: %s" % user_argv_conf_file)
                with open(user_argv_conf_file, "r+") as opened_file_lines:
                    new_data = []
                    for line in opened_file_lines.readlines():
                        if "locale" in line:
                            line = ""
                        new_data.append(line)
                    opened_file_lines.seek(0)  # Return to the top of the file
                    opened_file_lines.truncate(0)  # Erase next content of the file
                    opened_file_lines.writelines(new_data[0:])  # Writing new data to the file

    # Configuring node.cfg default preferences
    if isfile(node_cfg_file):
        file = open(node_cfg_file, "r")
        old_data = file.read()
        file.close()

        data = old_data
        data = data.replace("#UpdateFrequency 172800", "UpdateFrequency 0")
        data = data.replace("StartNXDaemon Automatic", "StartNXDaemon 0")

        new_data = data
        if not old_data == new_data:
            print("Writing configuration file with minimum instrusion parameters (%s)" % node_cfg_file)
            file = open(node_cfg_file, "w")
            file.write(data)
            file.close()

    # Cleanup sensitive data
    setup_path = makepath(pkg_dir, "setup.py")
    with open(setup_path, "r") as file:
        setup_content = file.read()
        setup_changed = False
        for s in sensitive_data_str_list:
            if s in setup_content:
                setup_content = setup_content.replace(s, "A" * len(s))
                setup_changed = True
    if setup_changed:
        with open(setup_path, "w") as file:
            file.write(setup_content)
        print("Sensitive data changed in: %s" % setup_path)


# read_write_file_replace
git_repo_conf_file_test = os.getcwd() + r"\zulu8\.git\config"

for repo in glob.glob("*"):
    if os.path.isdir(repo):
        git_repo_conf_file = r"%s\.git\config" % repo

    if os.path.isfile(git_repo_conf_file):
        with open(git_repo_conf_file, "r+") as open_data:
            new_data = [
                aline
                if not aline.startswith("	url = ")
                else aline.replace(
                    "url.ad.domain.lan/wapt-packages",
                    "urlbis.ad.domain.lan/wapt-packages",
                )
                for aline in open_data.readlines()
            ]
            open_data.seek(0)  # Return to the top of the file
            open_data.truncate(0)  # Erase next content of the file
            open_data.writelines(new_data[0:])  # Writing new data to the file

    # Configuring server DN
    with open(conf_file_path, "r+") as open_data:
        new_data = [aline if not aline.startswith("MeshServer") else "MeshServer=%s\n" % mesh_server_url for aline in open_data.readlines()]
        open_data.seek(0)  # Return to the top of the file
        open_data.truncate(0)  # Erase next content of the file
        open_data.writelines(new_data[0:])  # Writing new data to the file

    # read_write_file
    conf_file = "OpenBoardUser.config"
    conf_file_path = makepath(user_local_appdata, "OpenBoard", conf_file)

    if not isfile(conf_file_path):
        filecopyto(conf_file, conf_file_path)
    else:
        open_file = open(conf_file_path, "r")
        data_file = open_file.read()
        open_file.close()

        if "EnableAutomaticSoftwareUpdates=true" in data_file:
            data_file = data_file.replace(
                "EnableAutomaticSoftwareUpdates=true",
                "EnableAutomaticSoftwareUpdates=false",
            )

        open_file = open(conf_file_path, "w")
        open_file.write(data_file)
        open_file.close()


import chardet


def detect_file_encoding(filename):
    """Detect the encoding of a file."""
    with open(filename, "rb") as file:
        raw_data = file.read()
        result = chardet.detect(raw_data)
        return result["encoding"]
