# pip install pillow
from PIL import Image
from sys import argv
from os.path import splitext, exists
from os import remove

"""1st argument is the path to the image"""
"""Second argument is the new size (x)"""
"""Third argument is the new size (y)"""


def main():
    if len(argv) != 4:
        print("Wrong numbers of arguments", fd=stderr)
        exit(-1)

    """Initializing Values"""
    ImgName = argv[1]
    try:
        x = int(argv[2])
        y = int(argv[3])
    except ValueError:
        print("The size arguments aren't integers", fd=stderr)
        exit(-2)

    ImgToConvert = Image.open(argv[1])
    name, ext = splitext(ImgName)
    NewName = name + "converted.png"

    """Work on Image"""
    ImgConverted = ImgToConvert.resize((x, y))

    """Save the image, overwriting the existing one"""
    try:
        if exists(NewName):
            remove(NewName)
        ImgConverted.save(NewName)
    except Exception as E:
        print(E.error, fd=stderr)

    return 0


if __name__ == "__main__":
    main()
