# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    update_dict = {
        "bin_contains": {
            "windows-x64": "-Win64.exe",
            "mac-x64": "-MacOS-x86-64.pkg",
        },
        "latest_bin": {
            "windows-x64": "MicrosoftEdgeWebView2RuntimeInstallerX64.exe",
            "windows-x86": "MicrosoftEdgeWebView2RuntimeInstallerX86.exe",
            "windows-arm64": "MicrosoftEdgeWebView2RuntimeInstallerARM64.exe",
        },
        "download_url": {
            "windows-x64": "https://go.microsoft.com/fwlink/?linkid=2124701",
            "windows-x86": "https://go.microsoft.com/fwlink/?linkid=2099617",
            "windows-arm64": "https://go.microsoft.com/fwlink/?linkid=2099616",
        },
    }
    url = "https://developer.microsoft.com/en-us/microsoft-edge/webview2?form=MA13LH#download-section"
    url = update_dict["url"][f'{ensure_list(control.target_os)[0].split("(")[0]}-{ensure_list(control.architecture)[0]}']
    latest_bin = update_dict["latest_bin"][f'{ensure_list(control.target_os)[0].split("(")[0]}-{ensure_list(control.architecture)[0]}']
    download_url = update_dict["download_url"][f'{ensure_list(control.target_os)[0].split("(")[0]}-{ensure_list(control.architecture)[0]}']

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "a", proxies=proxies):
        if update_dict["bin_contains"][f'{ensure_list(control.target_os)[0].split("(")[0]}-{ensure_list(control.architecture)[0]}'] in bs_search.get(
            "href", ""
        ):
            download_url = bs_search["href"].rsplit(".mirrorlist")[0]
            latest_bin = download_url.split("/")[-1]
            version = latest_bin.split("-")[1]
            break

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)
    # arch_list = ensure_list(control.architecture)
    # remove_outdated_binaries(version, filename_contains=("x64" if "x64" in arch_list else "x86" if "x86" in arch_list else []))

    # Checking version from file
    if get_os_name() == "Windows" and "windows" in control.target_os.lower():
        version_from_file = get_version_from_binary(latest_bin)
        if Version(version_from_file, 4) == Version(version, 4):
            print(f"INFO: Binary file version ({version_from_file}) corresponds to online version ({version})")
        else:
            error(f"ERROR: Binary file version ({version_from_file}) do NOT corresponds to online version ({version})")

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
