# -*- coding: utf-8 -*-
from setuphelpers import *
import os
import sys

"""     
    "update_package_dependencies": [
        "tis-wapt-selenium",
        "tis-chrome"
    ]
"""


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://developer.microsoft.com/microsoft-edge/webview2/#download-section"
    download_dict = {
        "windows-x64": "MicrosoftEdgeWebView2RuntimeInstallerX64.exe",
        "windows-x86": "MicrosoftEdgeWebView2RuntimeInstallerX86.exe",
        "windows-arm64": "MicrosoftEdgeWebView2RuntimeInstallerARM64.exe",
    }
    latest_bin = download_dict[control.target_os + "-" + ensure_list(control.architecture)[0]]

    # Deleting binaries
    remove_outdated_binaries("*")

    # Importing Selenium using package tis-wapt-selenium
    wapt_selenium_dir = os.sep.join([sys.executable.rsplit(os.path.sep, 1)[0].replace("/bin", "").replace("\\Scripts", ""), "selenium"])
    driver_path = makepath(wapt_selenium_dir, "chromedriver.exe")
    user_agent = "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/118.0.5993.118 Safari/537.36"

    sys.path.insert(0, wapt_selenium_dir)
    from selenium import webdriver
    from selenium.webdriver.chrome.options import Options
    from selenium.webdriver.chrome.service import Service
    from selenium.webdriver.common.by import By
    from selenium.webdriver.support.select import Select

    # Selenium WebDriver initialization
    driver_options = Options()
    # driver_options.add_argument("--headless") # security limitations with headless flag
    driver_options.add_argument("--lang=en-us")
    driver_options.add_argument(f"--user-agent={user_agent}")
    driver_options.add_argument("--disable-notifications")
    driver_options.add_argument("--safebrowsing-disable-download-protection")
    driver_options.add_experimental_option(
        "prefs",
        {
            "download.default_directory": f"{basedir}",
            "download.prompt_for_download": False,
            "download.directory_upgrade": True,
            "safebrowsing_for_trusted_sources_enabled": False,
            "safebrowsing.enabled": True,
        },
    )
    driver = webdriver.Chrome(options=driver_options, service=Service(driver_path))

    # Downloading using Selenium
    driver.get(url)
    version = driver.find_element(By.XPATH, "/html/body/div[1]/div[2]/article/section[2]/section[2]/div/div[2]/div[3]/div/select[1]/option[1]").text
    driver.find_element(By.ID, control.architecture).click()
    driver.find_element(By.ID, "accept-evergreen").click()
    wait_download()
    driver.quit()

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)


def wait_download(delay=360):
    loop = 0
    while not glob.glob("*.exe"):
        loop += 3
        if loop > delay:
            break
        time.sleep(3)
