# -*- coding: utf-8 -*-
from setuphelpers import *
import time


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    # Formatting code with black
    formatting_print = str(run_notfatal("waptpython -m black -l 150 ."))
    time.sleep(8)
    if "reformatted" in formatting_print:
        print(ensure_unicode(formatting_print.split("\r\nAll done!")[0].split("\nAll done!")[0]))

    # Change package version based on commit_count
    if params.get("commit_count", 0):
        commit_count = params.get("commit_count", 0)
    else:
        commit_count = str(int(run("git rev-list HEAD --count").split("\n")[0]) + 1)
    split_version = control.get_software_version().split(".")
    split_version[2] = str(commit_count)
    version = ".".join(split_version)

    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
